// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/ConnectingLane.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/connecting_lane.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTING_LANE__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTING_LANE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/connecting_lane__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'lane'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__traits.hpp"
// Member 'maneuver'
#include "etsi_its_mapem_ts_msgs/msg/detail/allowed_maneuvers__traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ConnectingLane & msg,
  std::ostream & out)
{
  out << "{";
  // member: lane
  {
    out << "lane: ";
    to_flow_style_yaml(msg.lane, out);
    out << ", ";
  }

  // member: maneuver
  {
    out << "maneuver: ";
    to_flow_style_yaml(msg.maneuver, out);
    out << ", ";
  }

  // member: maneuver_is_present
  {
    out << "maneuver_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ConnectingLane & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lane
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane:\n";
    to_block_style_yaml(msg.lane, out, indentation + 2);
  }

  // member: maneuver
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver:\n";
    to_block_style_yaml(msg.maneuver, out, indentation + 2);
  }

  // member: maneuver_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ConnectingLane & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::ConnectingLane & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::ConnectingLane & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::ConnectingLane>()
{
  return "etsi_its_mapem_ts_msgs::msg::ConnectingLane";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::ConnectingLane>()
{
  return "etsi_its_mapem_ts_msgs/msg/ConnectingLane";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::ConnectingLane>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::LaneID>::value> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::ConnectingLane>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::LaneID>::value> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::ConnectingLane>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTING_LANE__TRAITS_HPP_
