// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/Connection.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/connection.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTION__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/connection__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'connecting_lane'
#include "etsi_its_mapem_ts_msgs/msg/detail/connecting_lane__traits.hpp"
// Member 'remote_intersection'
#include "etsi_its_mapem_ts_msgs/msg/detail/intersection_reference_id__traits.hpp"
// Member 'signal_group'
#include "etsi_its_mapem_ts_msgs/msg/detail/signal_group_id__traits.hpp"
// Member 'user_class'
#include "etsi_its_mapem_ts_msgs/msg/detail/restriction_class_id__traits.hpp"
// Member 'connection_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_connection_id__traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Connection & msg,
  std::ostream & out)
{
  out << "{";
  // member: connecting_lane
  {
    out << "connecting_lane: ";
    to_flow_style_yaml(msg.connecting_lane, out);
    out << ", ";
  }

  // member: remote_intersection
  {
    out << "remote_intersection: ";
    to_flow_style_yaml(msg.remote_intersection, out);
    out << ", ";
  }

  // member: remote_intersection_is_present
  {
    out << "remote_intersection_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.remote_intersection_is_present, out);
    out << ", ";
  }

  // member: signal_group
  {
    out << "signal_group: ";
    to_flow_style_yaml(msg.signal_group, out);
    out << ", ";
  }

  // member: signal_group_is_present
  {
    out << "signal_group_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.signal_group_is_present, out);
    out << ", ";
  }

  // member: user_class
  {
    out << "user_class: ";
    to_flow_style_yaml(msg.user_class, out);
    out << ", ";
  }

  // member: user_class_is_present
  {
    out << "user_class_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.user_class_is_present, out);
    out << ", ";
  }

  // member: connection_id
  {
    out << "connection_id: ";
    to_flow_style_yaml(msg.connection_id, out);
    out << ", ";
  }

  // member: connection_id_is_present
  {
    out << "connection_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connection_id_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Connection & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: connecting_lane
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connecting_lane:\n";
    to_block_style_yaml(msg.connecting_lane, out, indentation + 2);
  }

  // member: remote_intersection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remote_intersection:\n";
    to_block_style_yaml(msg.remote_intersection, out, indentation + 2);
  }

  // member: remote_intersection_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remote_intersection_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.remote_intersection_is_present, out);
    out << "\n";
  }

  // member: signal_group
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "signal_group:\n";
    to_block_style_yaml(msg.signal_group, out, indentation + 2);
  }

  // member: signal_group_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "signal_group_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.signal_group_is_present, out);
    out << "\n";
  }

  // member: user_class
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "user_class:\n";
    to_block_style_yaml(msg.user_class, out, indentation + 2);
  }

  // member: user_class_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "user_class_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.user_class_is_present, out);
    out << "\n";
  }

  // member: connection_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connection_id:\n";
    to_block_style_yaml(msg.connection_id, out, indentation + 2);
  }

  // member: connection_id_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connection_id_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connection_id_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Connection & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::Connection & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::Connection & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::Connection>()
{
  return "etsi_its_mapem_ts_msgs::msg::Connection";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::Connection>()
{
  return "etsi_its_mapem_ts_msgs/msg/Connection";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::Connection>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mapem_ts_msgs::msg::ConnectingLane>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::IntersectionReferenceID>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::LaneConnectionID>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::RestrictionClassID>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::SignalGroupID>::value> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::Connection>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mapem_ts_msgs::msg::ConnectingLane>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::IntersectionReferenceID>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::LaneConnectionID>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::RestrictionClassID>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::SignalGroupID>::value> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::Connection>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__CONNECTION__TRAITS_HPP_
