// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/DataParameters.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/data_parameters.h"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'PROCESS_METHOD_MIN_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__PROCESS_METHOD_MIN_SIZE = 1
};

/// Constant 'PROCESS_METHOD_MAX_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__PROCESS_METHOD_MAX_SIZE = 255
};

/// Constant 'PROCESS_AGENCY_MIN_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__PROCESS_AGENCY_MIN_SIZE = 1
};

/// Constant 'PROCESS_AGENCY_MAX_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__PROCESS_AGENCY_MAX_SIZE = 255
};

/// Constant 'LAST_CHECKED_DATE_MIN_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__LAST_CHECKED_DATE_MIN_SIZE = 1
};

/// Constant 'LAST_CHECKED_DATE_MAX_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__LAST_CHECKED_DATE_MAX_SIZE = 255
};

/// Constant 'GEOID_USED_MIN_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__GEOID_USED_MIN_SIZE = 1
};

/// Constant 'GEOID_USED_MAX_SIZE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__DataParameters__GEOID_USED_MAX_SIZE = 255
};

// Include directives for member types
// Member 'process_method'
// Member 'process_agency'
// Member 'last_checked_date'
// Member 'geoid_used'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/DataParameters in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__DataParameters
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// DataParameters ::= SEQUENCE {
  ///   processMethod     IA5String(SIZE(1..255)) OPTIONAL,
  ///   processAgency     IA5String(SIZE(1..255)) OPTIONAL,
  ///   lastCheckedDate   IA5String(SIZE(1..255)) OPTIONAL,
  ///   geoidUsed         IA5String(SIZE(1..255)) OPTIONAL,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__String process_method;
  bool process_method_is_present;
  rosidl_runtime_c__String process_agency;
  bool process_agency_is_present;
  rosidl_runtime_c__String last_checked_date;
  bool last_checked_date_is_present;
  rosidl_runtime_c__String geoid_used;
  bool geoid_used_is_present;
} etsi_its_mapem_ts_msgs__msg__DataParameters;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__DataParameters.
typedef struct etsi_its_mapem_ts_msgs__msg__DataParameters__Sequence
{
  etsi_its_mapem_ts_msgs__msg__DataParameters * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__DataParameters__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__STRUCT_H_
