// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/LaneAttributesBarrier.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/lane_attributes_barrier.h"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_ATTRIBUTES_BARRIER__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_ATTRIBUTES_BARRIER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__SIZE_BITS = 16
};

/// Constant 'BIT_INDEX_MEDIAN_REVOCABLE_LANE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_MEDIAN_REVOCABLE_LANE = 0
};

/// Constant 'BIT_INDEX_MEDIAN'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_MEDIAN = 1
};

/// Constant 'BIT_INDEX_WHITE_LINE_HASHING'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_WHITE_LINE_HASHING = 2
};

/// Constant 'BIT_INDEX_STRIPED_LINES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_STRIPED_LINES = 3
};

/// Constant 'BIT_INDEX_DOUBLE_STRIPED_LINES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_DOUBLE_STRIPED_LINES = 4
};

/// Constant 'BIT_INDEX_TRAFFIC_CONES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_TRAFFIC_CONES = 5
};

/// Constant 'BIT_INDEX_CONSTRUCTION_BARRIER'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_CONSTRUCTION_BARRIER = 6
};

/// Constant 'BIT_INDEX_TRAFFIC_CHANNELS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_TRAFFIC_CHANNELS = 7
};

/// Constant 'BIT_INDEX_LOW_CURBS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_LOW_CURBS = 8
};

/// Constant 'BIT_INDEX_HIGH_CURBS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__BIT_INDEX_HIGH_CURBS = 9
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/LaneAttributesBarrier in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LaneAttributes-Barrier ::= BIT STRING {
  ///   median-RevocableLane     (0),
  ///   median                   (1),
  ///   whiteLineHashing         (2),
  ///   stripedLines             (3),
  ///   doubleStripedLines       (4),
  ///   trafficCones             (5),
  ///   constructionBarrier      (6),
  ///   trafficChannels          (7),
  ///   lowCurbs                 (8),
  ///   highCurbs                (9)
  /// } (SIZE (16))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier.
typedef struct etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__Sequence
{
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_ATTRIBUTES_BARRIER__STRUCT_H_
