// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/LaneDataAttribute.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/lane_data_attribute.h"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_DATA_ATTRIBUTE__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_DATA_ATTRIBUTE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CHOICE_PATH_END_POINT_ANGLE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__CHOICE_PATH_END_POINT_ANGLE = 0
};

/// Constant 'CHOICE_LANE_CROWN_POINT_CENTER'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__CHOICE_LANE_CROWN_POINT_CENTER = 1
};

/// Constant 'CHOICE_LANE_CROWN_POINT_LEFT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__CHOICE_LANE_CROWN_POINT_LEFT = 2
};

/// Constant 'CHOICE_LANE_CROWN_POINT_RIGHT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__CHOICE_LANE_CROWN_POINT_RIGHT = 3
};

/// Constant 'CHOICE_LANE_ANGLE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__CHOICE_LANE_ANGLE = 4
};

/// Constant 'CHOICE_SPEED_LIMITS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__CHOICE_SPEED_LIMITS = 5
};

// Include directives for member types
// Member 'path_end_point_angle'
#include "etsi_its_mapem_ts_msgs/msg/detail/delta_angle__struct.h"
// Member 'lane_crown_point_center'
// Member 'lane_crown_point_left'
// Member 'lane_crown_point_right'
#include "etsi_its_mapem_ts_msgs/msg/detail/roadway_crown_angle__struct.h"
// Member 'lane_angle'
#include "etsi_its_mapem_ts_msgs/msg/detail/merge_diverge_node_angle__struct.h"
// Member 'speed_limits'
#include "etsi_its_mapem_ts_msgs/msg/detail/speed_limit_list__struct.h"

/// Struct defined in msg/LaneDataAttribute in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__LaneDataAttribute
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LaneDataAttribute ::= CHOICE {
  ///    pathEndPointAngle        DeltaAngle,
  ///    laneCrownPointCenter     RoadwayCrownAngle,
  ///    laneCrownPointLeft       RoadwayCrownAngle,
  ///    laneCrownPointRight      RoadwayCrownAngle,
  ///    laneAngle                MergeDivergeNodeAngle,
  ///    speedLimits              SpeedLimitList,
  ///    regional  SEQUENCE (SIZE(1..4)) OF
  ///              RegionalExtension {{Reg-LaneDataAttribute}},
  ///    ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_mapem_ts_msgs__msg__DeltaAngle path_end_point_angle;
  etsi_its_mapem_ts_msgs__msg__RoadwayCrownAngle lane_crown_point_center;
  etsi_its_mapem_ts_msgs__msg__RoadwayCrownAngle lane_crown_point_left;
  etsi_its_mapem_ts_msgs__msg__RoadwayCrownAngle lane_crown_point_right;
  etsi_its_mapem_ts_msgs__msg__MergeDivergeNodeAngle lane_angle;
  etsi_its_mapem_ts_msgs__msg__SpeedLimitList speed_limits;
} etsi_its_mapem_ts_msgs__msg__LaneDataAttribute;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__LaneDataAttribute.
typedef struct etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__Sequence
{
  etsi_its_mapem_ts_msgs__msg__LaneDataAttribute * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__LaneDataAttribute__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_DATA_ATTRIBUTE__STRUCT_H_
