// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/LaneTypeAttributes.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/lane_type_attributes.h"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_TYPE_ATTRIBUTES__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_TYPE_ATTRIBUTES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'CHOICE_VEHICLE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_VEHICLE = 0
};

/// Constant 'CHOICE_CROSSWALK'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_CROSSWALK = 1
};

/// Constant 'CHOICE_BIKE_LANE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_BIKE_LANE = 2
};

/// Constant 'CHOICE_SIDEWALK'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_SIDEWALK = 3
};

/// Constant 'CHOICE_MEDIAN'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_MEDIAN = 4
};

/// Constant 'CHOICE_STRIPING'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_STRIPING = 5
};

/// Constant 'CHOICE_TRACKED_VEHICLE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_TRACKED_VEHICLE = 6
};

/// Constant 'CHOICE_PARKING'.
enum
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__CHOICE_PARKING = 7
};

// Include directives for member types
// Member 'vehicle'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_vehicle__struct.h"
// Member 'crosswalk'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_crosswalk__struct.h"
// Member 'bike_lane'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_bike__struct.h"
// Member 'sidewalk'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_sidewalk__struct.h"
// Member 'median'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_barrier__struct.h"
// Member 'striping'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_striping__struct.h"
// Member 'tracked_vehicle'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_tracked_vehicle__struct.h"
// Member 'parking'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes_parking__struct.h"

/// Struct defined in msg/LaneTypeAttributes in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// LaneTypeAttributes ::= CHOICE {
  ///   vehicle        LaneAttributes-Vehicle,
  ///   crosswalk      LaneAttributes-Crosswalk,
  ///   bikeLane       LaneAttributes-Bike,
  ///   sidewalk       LaneAttributes-Sidewalk,
  ///   median         LaneAttributes-Barrier,
  ///   striping       LaneAttributes-Striping,
  ///   trackedVehicle LaneAttributes-TrackedVehicle,
  ///   parking        LaneAttributes-Parking,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t choice;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesVehicle vehicle;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesCrosswalk crosswalk;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBike bike_lane;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesSidewalk sidewalk;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesBarrier median;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesStriping striping;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesTrackedVehicle tracked_vehicle;
  etsi_its_mapem_ts_msgs__msg__LaneAttributesParking parking;
} etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes.
typedef struct etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__Sequence
{
  etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__LaneTypeAttributes__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__LANE_TYPE_ATTRIBUTES__STRUCT_H_
