// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/NodeAttributeXY.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/node_attribute_xy.h"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_XY__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_XY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'RESERVED'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__RESERVED = 0
};

/// Constant 'STOP_LINE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__STOP_LINE = 1
};

/// Constant 'ROUNDED_CAP_STYLE_A'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__ROUNDED_CAP_STYLE_A = 2
};

/// Constant 'ROUNDED_CAP_STYLE_B'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__ROUNDED_CAP_STYLE_B = 3
};

/// Constant 'MERGE_POINT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__MERGE_POINT = 4
};

/// Constant 'DIVERGE_POINT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__DIVERGE_POINT = 5
};

/// Constant 'DOWNSTREAM_STOP_LINE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__DOWNSTREAM_STOP_LINE = 6
};

/// Constant 'DOWNSTREAM_START_NODE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__DOWNSTREAM_START_NODE = 7
};

/// Constant 'CLOSED_TO_TRAFFIC'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__CLOSED_TO_TRAFFIC = 8
};

/// Constant 'SAFE_ISLAND'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__SAFE_ISLAND = 9
};

/// Constant 'CURB_PRESENT_AT_STEP_OFF'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__CURB_PRESENT_AT_STEP_OFF = 10
};

/// Constant 'HYDRANT_PRESENT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__HYDRANT_PRESENT = 11
};

/// Struct defined in msg/NodeAttributeXY in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__NodeAttributeXY
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// NodeAttributeXY ::= ENUMERATED {
  ///   reserved,
  ///   stopLine,
  ///   roundedCapStyleA,
  ///   roundedCapStyleB,
  ///   mergePoint,
  ///   divergePoint,
  ///   downstreamStopLine,
  ///   downstreamStartNode,
  ///   closedToTraffic,
  ///   safeIsland,
  ///   curbPresentAtStepOff,
  ///   hydrantPresent,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_mapem_ts_msgs__msg__NodeAttributeXY;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__NodeAttributeXY.
typedef struct etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__Sequence
{
  etsi_its_mapem_ts_msgs__msg__NodeAttributeXY * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__NodeAttributeXY__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__NODE_ATTRIBUTE_XY__STRUCT_H_
