// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mapem_ts_msgs:msg/NodeXY.idl
// generated code does not contain a copyright notice
#include "etsi_its_mapem_ts_msgs/msg/detail/node_xy__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `delta`
#include "etsi_its_mapem_ts_msgs/msg/detail/node_offset_point_xy__functions.h"
// Member `attributes`
#include "etsi_its_mapem_ts_msgs/msg/detail/node_attribute_set_xy__functions.h"

bool
etsi_its_mapem_ts_msgs__msg__NodeXY__init(etsi_its_mapem_ts_msgs__msg__NodeXY * msg)
{
  if (!msg) {
    return false;
  }
  // delta
  if (!etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__init(&msg->delta)) {
    etsi_its_mapem_ts_msgs__msg__NodeXY__fini(msg);
    return false;
  }
  // attributes
  if (!etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY__init(&msg->attributes)) {
    etsi_its_mapem_ts_msgs__msg__NodeXY__fini(msg);
    return false;
  }
  // attributes_is_present
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__NodeXY__fini(etsi_its_mapem_ts_msgs__msg__NodeXY * msg)
{
  if (!msg) {
    return;
  }
  // delta
  etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__fini(&msg->delta);
  // attributes
  etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY__fini(&msg->attributes);
  // attributes_is_present
}

bool
etsi_its_mapem_ts_msgs__msg__NodeXY__are_equal(const etsi_its_mapem_ts_msgs__msg__NodeXY * lhs, const etsi_its_mapem_ts_msgs__msg__NodeXY * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // delta
  if (!etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__are_equal(
      &(lhs->delta), &(rhs->delta)))
  {
    return false;
  }
  // attributes
  if (!etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY__are_equal(
      &(lhs->attributes), &(rhs->attributes)))
  {
    return false;
  }
  // attributes_is_present
  if (lhs->attributes_is_present != rhs->attributes_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__NodeXY__copy(
  const etsi_its_mapem_ts_msgs__msg__NodeXY * input,
  etsi_its_mapem_ts_msgs__msg__NodeXY * output)
{
  if (!input || !output) {
    return false;
  }
  // delta
  if (!etsi_its_mapem_ts_msgs__msg__NodeOffsetPointXY__copy(
      &(input->delta), &(output->delta)))
  {
    return false;
  }
  // attributes
  if (!etsi_its_mapem_ts_msgs__msg__NodeAttributeSetXY__copy(
      &(input->attributes), &(output->attributes)))
  {
    return false;
  }
  // attributes_is_present
  output->attributes_is_present = input->attributes_is_present;
  return true;
}

etsi_its_mapem_ts_msgs__msg__NodeXY *
etsi_its_mapem_ts_msgs__msg__NodeXY__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__NodeXY * msg = (etsi_its_mapem_ts_msgs__msg__NodeXY *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__NodeXY), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mapem_ts_msgs__msg__NodeXY));
  bool success = etsi_its_mapem_ts_msgs__msg__NodeXY__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mapem_ts_msgs__msg__NodeXY__destroy(etsi_its_mapem_ts_msgs__msg__NodeXY * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mapem_ts_msgs__msg__NodeXY__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__init(etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__NodeXY * data = NULL;

  if (size) {
    data = (etsi_its_mapem_ts_msgs__msg__NodeXY *)allocator.zero_allocate(size, sizeof(etsi_its_mapem_ts_msgs__msg__NodeXY), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mapem_ts_msgs__msg__NodeXY__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mapem_ts_msgs__msg__NodeXY__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__fini(etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mapem_ts_msgs__msg__NodeXY__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence *
etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * array = (etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__destroy(etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__are_equal(const etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * lhs, const etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__NodeXY__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence__copy(
  const etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * input,
  etsi_its_mapem_ts_msgs__msg__NodeXY__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mapem_ts_msgs__msg__NodeXY);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mapem_ts_msgs__msg__NodeXY * data =
      (etsi_its_mapem_ts_msgs__msg__NodeXY *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mapem_ts_msgs__msg__NodeXY__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mapem_ts_msgs__msg__NodeXY__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__NodeXY__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
