// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mapem_ts_msgs:msg/RestrictionAppliesTo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/restriction_applies_to.h"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__RESTRICTION_APPLIES_TO__STRUCT_H_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__RESTRICTION_APPLIES_TO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'NONE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__NONE = 0
};

/// Constant 'EQUIPPED_TRANSIT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__EQUIPPED_TRANSIT = 1
};

/// Constant 'EQUIPPED_TAXIS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__EQUIPPED_TAXIS = 2
};

/// Constant 'EQUIPPED_OTHER'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__EQUIPPED_OTHER = 3
};

/// Constant 'EMISSION_COMPLIANT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__EMISSION_COMPLIANT = 4
};

/// Constant 'EQUIPPED_BICYCLE'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__EQUIPPED_BICYCLE = 5
};

/// Constant 'WEIGHT_COMPLIANT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__WEIGHT_COMPLIANT = 6
};

/// Constant 'HEIGHT_COMPLIANT'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__HEIGHT_COMPLIANT = 7
};

/// Constant 'PEDESTRIANS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__PEDESTRIANS = 8
};

/// Constant 'SLOW_MOVING_PERSONS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__SLOW_MOVING_PERSONS = 9
};

/// Constant 'WHEELCHAIR_USERS'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__WHEELCHAIR_USERS = 10
};

/// Constant 'VISUAL_DISABILITIES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__VISUAL_DISABILITIES = 11
};

/// Constant 'AUDIO_DISABILITIES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__AUDIO_DISABILITIES = 12
};

/// Constant 'OTHER_UNKNOWN_DISABILITIES'.
enum
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__OTHER_UNKNOWN_DISABILITIES = 13
};

/// Struct defined in msg/RestrictionAppliesTo in the package etsi_its_mapem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/MAPEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   mapem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_mapem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// RestrictionAppliesTo ::= ENUMERATED {
  ///   none,
  ///   equippedTransit,
  ///   equippedTaxis,
  ///   equippedOther,
  ///   emissionCompliant,
  ///   equippedBicycle,
  ///   weightCompliant,
  ///   heightCompliant,
  ///   pedestrians,
  ///   slowMovingPersons,
  ///   wheelchairUsers,
  ///   visualDisabilities,
  ///   audioDisabilities,
  ///   otherUnknownDisabilities,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo;

// Struct for a sequence of etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo.
typedef struct etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__Sequence
{
  etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__RESTRICTION_APPLIES_TO__STRUCT_H_
