// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/AllowedManeuvers.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/allowed_maneuvers.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ALLOWED_MANEUVERS__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ALLOWED_MANEUVERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__AllowedManeuvers __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__AllowedManeuvers __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AllowedManeuvers_
{
  using Type = AllowedManeuvers_<ContainerAllocator>;

  explicit AllowedManeuvers_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  explicit AllowedManeuvers_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->bits_unused = 0;
    }
  }

  // field types and members
  using _value_type =
    std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>>;
  _value_type value;
  using _bits_unused_type =
    uint8_t;
  _bits_unused_type bits_unused;

  // setters for named parameter idiom
  Type & set__value(
    const std::vector<uint8_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<uint8_t>> & _arg)
  {
    this->value = _arg;
    return *this;
  }
  Type & set__bits_unused(
    const uint8_t & _arg)
  {
    this->bits_unused = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t SIZE_BITS =
    12u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_STRAIGHT_ALLOWED =
    0u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_LEFT_ALLOWED =
    1u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_RIGHT_ALLOWED =
    2u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_U_TURN_ALLOWED =
    3u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_LEFT_TURN_ON_RED_ALLOWED =
    4u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_RIGHT_TURN_ON_RED_ALLOWED =
    5u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_LANE_CHANGE_ALLOWED =
    6u;
  static constexpr uint8_t BIT_INDEX_MANEUVER_NO_STOPPING_ALLOWED =
    7u;
  static constexpr uint8_t BIT_INDEX_YIELD_ALLWAYS_REQUIRED =
    8u;
  static constexpr uint8_t BIT_INDEX_GO_WITH_HALT =
    9u;
  static constexpr uint8_t BIT_INDEX_CAUTION =
    10u;
  static constexpr uint8_t BIT_INDEX_RESERVED1 =
    11u;

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__AllowedManeuvers
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__AllowedManeuvers
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AllowedManeuvers_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    if (this->bits_unused != other.bits_unused) {
      return false;
    }
    return true;
  }
  bool operator!=(const AllowedManeuvers_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AllowedManeuvers_

// alias to use template instance with default allocator
using AllowedManeuvers =
  etsi_its_mapem_ts_msgs::msg::AllowedManeuvers_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::SIZE_BITS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_STRAIGHT_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_LEFT_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_RIGHT_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_U_TURN_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_LEFT_TURN_ON_RED_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_RIGHT_TURN_ON_RED_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_LANE_CHANGE_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_MANEUVER_NO_STOPPING_ALLOWED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_YIELD_ALLWAYS_REQUIRED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_GO_WITH_HALT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_CAUTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t AllowedManeuvers_<ContainerAllocator>::BIT_INDEX_RESERVED1;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__ALLOWED_MANEUVERS__STRUCT_HPP_
