// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/ComputedLane.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/computed_lane.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'reference_lane_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__struct.hpp"
// Member 'offset_xaxis_small'
// Member 'offset_yaxis_small'
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_sm__struct.hpp"
// Member 'offset_xaxis_large'
// Member 'offset_yaxis_large'
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_lg__struct.hpp"
// Member 'rotate_xy'
#include "etsi_its_mapem_ts_msgs/msg/detail/angle__struct.hpp"
// Member 'scale_xaxis'
// Member 'scale_yaxis'
#include "etsi_its_mapem_ts_msgs/msg/detail/scale_b12__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__ComputedLane __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__ComputedLane __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ComputedLane_
{
  using Type = ComputedLane_<ContainerAllocator>;

  explicit ComputedLane_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : reference_lane_id(_init),
    offset_xaxis_small(_init),
    offset_xaxis_large(_init),
    offset_yaxis_small(_init),
    offset_yaxis_large(_init),
    rotate_xy(_init),
    scale_xaxis(_init),
    scale_yaxis(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->offset_xaxis_choice = 0;
      this->offset_yaxis_choice = 0;
      this->rotate_xy_is_present = false;
      this->scale_xaxis_is_present = false;
      this->scale_yaxis_is_present = false;
    }
  }

  explicit ComputedLane_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : reference_lane_id(_alloc, _init),
    offset_xaxis_small(_alloc, _init),
    offset_xaxis_large(_alloc, _init),
    offset_yaxis_small(_alloc, _init),
    offset_yaxis_large(_alloc, _init),
    rotate_xy(_alloc, _init),
    scale_xaxis(_alloc, _init),
    scale_yaxis(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->offset_xaxis_choice = 0;
      this->offset_yaxis_choice = 0;
      this->rotate_xy_is_present = false;
      this->scale_xaxis_is_present = false;
      this->scale_yaxis_is_present = false;
    }
  }

  // field types and members
  using _reference_lane_id_type =
    etsi_its_mapem_ts_msgs::msg::LaneID_<ContainerAllocator>;
  _reference_lane_id_type reference_lane_id;
  using _offset_xaxis_choice_type =
    uint8_t;
  _offset_xaxis_choice_type offset_xaxis_choice;
  using _offset_xaxis_small_type =
    etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetSm_<ContainerAllocator>;
  _offset_xaxis_small_type offset_xaxis_small;
  using _offset_xaxis_large_type =
    etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetLg_<ContainerAllocator>;
  _offset_xaxis_large_type offset_xaxis_large;
  using _offset_yaxis_choice_type =
    uint8_t;
  _offset_yaxis_choice_type offset_yaxis_choice;
  using _offset_yaxis_small_type =
    etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetSm_<ContainerAllocator>;
  _offset_yaxis_small_type offset_yaxis_small;
  using _offset_yaxis_large_type =
    etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetLg_<ContainerAllocator>;
  _offset_yaxis_large_type offset_yaxis_large;
  using _rotate_xy_type =
    etsi_its_mapem_ts_msgs::msg::Angle_<ContainerAllocator>;
  _rotate_xy_type rotate_xy;
  using _rotate_xy_is_present_type =
    bool;
  _rotate_xy_is_present_type rotate_xy_is_present;
  using _scale_xaxis_type =
    etsi_its_mapem_ts_msgs::msg::ScaleB12_<ContainerAllocator>;
  _scale_xaxis_type scale_xaxis;
  using _scale_xaxis_is_present_type =
    bool;
  _scale_xaxis_is_present_type scale_xaxis_is_present;
  using _scale_yaxis_type =
    etsi_its_mapem_ts_msgs::msg::ScaleB12_<ContainerAllocator>;
  _scale_yaxis_type scale_yaxis;
  using _scale_yaxis_is_present_type =
    bool;
  _scale_yaxis_is_present_type scale_yaxis_is_present;

  // setters for named parameter idiom
  Type & set__reference_lane_id(
    const etsi_its_mapem_ts_msgs::msg::LaneID_<ContainerAllocator> & _arg)
  {
    this->reference_lane_id = _arg;
    return *this;
  }
  Type & set__offset_xaxis_choice(
    const uint8_t & _arg)
  {
    this->offset_xaxis_choice = _arg;
    return *this;
  }
  Type & set__offset_xaxis_small(
    const etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetSm_<ContainerAllocator> & _arg)
  {
    this->offset_xaxis_small = _arg;
    return *this;
  }
  Type & set__offset_xaxis_large(
    const etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetLg_<ContainerAllocator> & _arg)
  {
    this->offset_xaxis_large = _arg;
    return *this;
  }
  Type & set__offset_yaxis_choice(
    const uint8_t & _arg)
  {
    this->offset_yaxis_choice = _arg;
    return *this;
  }
  Type & set__offset_yaxis_small(
    const etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetSm_<ContainerAllocator> & _arg)
  {
    this->offset_yaxis_small = _arg;
    return *this;
  }
  Type & set__offset_yaxis_large(
    const etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetLg_<ContainerAllocator> & _arg)
  {
    this->offset_yaxis_large = _arg;
    return *this;
  }
  Type & set__rotate_xy(
    const etsi_its_mapem_ts_msgs::msg::Angle_<ContainerAllocator> & _arg)
  {
    this->rotate_xy = _arg;
    return *this;
  }
  Type & set__rotate_xy_is_present(
    const bool & _arg)
  {
    this->rotate_xy_is_present = _arg;
    return *this;
  }
  Type & set__scale_xaxis(
    const etsi_its_mapem_ts_msgs::msg::ScaleB12_<ContainerAllocator> & _arg)
  {
    this->scale_xaxis = _arg;
    return *this;
  }
  Type & set__scale_xaxis_is_present(
    const bool & _arg)
  {
    this->scale_xaxis_is_present = _arg;
    return *this;
  }
  Type & set__scale_yaxis(
    const etsi_its_mapem_ts_msgs::msg::ScaleB12_<ContainerAllocator> & _arg)
  {
    this->scale_yaxis = _arg;
    return *this;
  }
  Type & set__scale_yaxis_is_present(
    const bool & _arg)
  {
    this->scale_yaxis_is_present = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_OFFSET_XAXIS_SMALL =
    0u;
  static constexpr uint8_t CHOICE_OFFSET_XAXIS_LARGE =
    1u;
  static constexpr uint8_t CHOICE_OFFSET_YAXIS_SMALL =
    0u;
  static constexpr uint8_t CHOICE_OFFSET_YAXIS_LARGE =
    1u;

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__ComputedLane
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__ComputedLane
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::ComputedLane_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ComputedLane_ & other) const
  {
    if (this->reference_lane_id != other.reference_lane_id) {
      return false;
    }
    if (this->offset_xaxis_choice != other.offset_xaxis_choice) {
      return false;
    }
    if (this->offset_xaxis_small != other.offset_xaxis_small) {
      return false;
    }
    if (this->offset_xaxis_large != other.offset_xaxis_large) {
      return false;
    }
    if (this->offset_yaxis_choice != other.offset_yaxis_choice) {
      return false;
    }
    if (this->offset_yaxis_small != other.offset_yaxis_small) {
      return false;
    }
    if (this->offset_yaxis_large != other.offset_yaxis_large) {
      return false;
    }
    if (this->rotate_xy != other.rotate_xy) {
      return false;
    }
    if (this->rotate_xy_is_present != other.rotate_xy_is_present) {
      return false;
    }
    if (this->scale_xaxis != other.scale_xaxis) {
      return false;
    }
    if (this->scale_xaxis_is_present != other.scale_xaxis_is_present) {
      return false;
    }
    if (this->scale_yaxis != other.scale_yaxis) {
      return false;
    }
    if (this->scale_yaxis_is_present != other.scale_yaxis_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const ComputedLane_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ComputedLane_

// alias to use template instance with default allocator
using ComputedLane =
  etsi_its_mapem_ts_msgs::msg::ComputedLane_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ComputedLane_<ContainerAllocator>::CHOICE_OFFSET_XAXIS_SMALL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ComputedLane_<ContainerAllocator>::CHOICE_OFFSET_XAXIS_LARGE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ComputedLane_<ContainerAllocator>::CHOICE_OFFSET_YAXIS_SMALL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ComputedLane_<ContainerAllocator>::CHOICE_OFFSET_YAXIS_LARGE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__STRUCT_HPP_
