// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/ComputedLane.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/computed_lane.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/computed_lane__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'reference_lane_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__traits.hpp"
// Member 'offset_xaxis_small'
// Member 'offset_yaxis_small'
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_sm__traits.hpp"
// Member 'offset_xaxis_large'
// Member 'offset_yaxis_large'
#include "etsi_its_mapem_ts_msgs/msg/detail/driven_line_offset_lg__traits.hpp"
// Member 'rotate_xy'
#include "etsi_its_mapem_ts_msgs/msg/detail/angle__traits.hpp"
// Member 'scale_xaxis'
// Member 'scale_yaxis'
#include "etsi_its_mapem_ts_msgs/msg/detail/scale_b12__traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ComputedLane & msg,
  std::ostream & out)
{
  out << "{";
  // member: reference_lane_id
  {
    out << "reference_lane_id: ";
    to_flow_style_yaml(msg.reference_lane_id, out);
    out << ", ";
  }

  // member: offset_xaxis_choice
  {
    out << "offset_xaxis_choice: ";
    rosidl_generator_traits::value_to_yaml(msg.offset_xaxis_choice, out);
    out << ", ";
  }

  // member: offset_xaxis_small
  {
    out << "offset_xaxis_small: ";
    to_flow_style_yaml(msg.offset_xaxis_small, out);
    out << ", ";
  }

  // member: offset_xaxis_large
  {
    out << "offset_xaxis_large: ";
    to_flow_style_yaml(msg.offset_xaxis_large, out);
    out << ", ";
  }

  // member: offset_yaxis_choice
  {
    out << "offset_yaxis_choice: ";
    rosidl_generator_traits::value_to_yaml(msg.offset_yaxis_choice, out);
    out << ", ";
  }

  // member: offset_yaxis_small
  {
    out << "offset_yaxis_small: ";
    to_flow_style_yaml(msg.offset_yaxis_small, out);
    out << ", ";
  }

  // member: offset_yaxis_large
  {
    out << "offset_yaxis_large: ";
    to_flow_style_yaml(msg.offset_yaxis_large, out);
    out << ", ";
  }

  // member: rotate_xy
  {
    out << "rotate_xy: ";
    to_flow_style_yaml(msg.rotate_xy, out);
    out << ", ";
  }

  // member: rotate_xy_is_present
  {
    out << "rotate_xy_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.rotate_xy_is_present, out);
    out << ", ";
  }

  // member: scale_xaxis
  {
    out << "scale_xaxis: ";
    to_flow_style_yaml(msg.scale_xaxis, out);
    out << ", ";
  }

  // member: scale_xaxis_is_present
  {
    out << "scale_xaxis_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.scale_xaxis_is_present, out);
    out << ", ";
  }

  // member: scale_yaxis
  {
    out << "scale_yaxis: ";
    to_flow_style_yaml(msg.scale_yaxis, out);
    out << ", ";
  }

  // member: scale_yaxis_is_present
  {
    out << "scale_yaxis_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.scale_yaxis_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ComputedLane & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: reference_lane_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_lane_id:\n";
    to_block_style_yaml(msg.reference_lane_id, out, indentation + 2);
  }

  // member: offset_xaxis_choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "offset_xaxis_choice: ";
    rosidl_generator_traits::value_to_yaml(msg.offset_xaxis_choice, out);
    out << "\n";
  }

  // member: offset_xaxis_small
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "offset_xaxis_small:\n";
    to_block_style_yaml(msg.offset_xaxis_small, out, indentation + 2);
  }

  // member: offset_xaxis_large
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "offset_xaxis_large:\n";
    to_block_style_yaml(msg.offset_xaxis_large, out, indentation + 2);
  }

  // member: offset_yaxis_choice
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "offset_yaxis_choice: ";
    rosidl_generator_traits::value_to_yaml(msg.offset_yaxis_choice, out);
    out << "\n";
  }

  // member: offset_yaxis_small
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "offset_yaxis_small:\n";
    to_block_style_yaml(msg.offset_yaxis_small, out, indentation + 2);
  }

  // member: offset_yaxis_large
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "offset_yaxis_large:\n";
    to_block_style_yaml(msg.offset_yaxis_large, out, indentation + 2);
  }

  // member: rotate_xy
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rotate_xy:\n";
    to_block_style_yaml(msg.rotate_xy, out, indentation + 2);
  }

  // member: rotate_xy_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rotate_xy_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.rotate_xy_is_present, out);
    out << "\n";
  }

  // member: scale_xaxis
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scale_xaxis:\n";
    to_block_style_yaml(msg.scale_xaxis, out, indentation + 2);
  }

  // member: scale_xaxis_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scale_xaxis_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.scale_xaxis_is_present, out);
    out << "\n";
  }

  // member: scale_yaxis
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scale_yaxis:\n";
    to_block_style_yaml(msg.scale_yaxis, out, indentation + 2);
  }

  // member: scale_yaxis_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scale_yaxis_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.scale_yaxis_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ComputedLane & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::ComputedLane & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::ComputedLane & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::ComputedLane>()
{
  return "etsi_its_mapem_ts_msgs::msg::ComputedLane";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::ComputedLane>()
{
  return "etsi_its_mapem_ts_msgs/msg/ComputedLane";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::ComputedLane>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mapem_ts_msgs::msg::Angle>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetLg>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetSm>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::LaneID>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::ScaleB12>::value> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::ComputedLane>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mapem_ts_msgs::msg::Angle>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetLg>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::DrivenLineOffsetSm>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::LaneID>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::ScaleB12>::value> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::ComputedLane>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__COMPUTED_LANE__TRAITS_HPP_
