// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/DataParameters.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/data_parameters.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__DataParameters __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__DataParameters __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DataParameters_
{
  using Type = DataParameters_<ContainerAllocator>;

  explicit DataParameters_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->process_method = "";
      this->process_method_is_present = false;
      this->process_agency = "";
      this->process_agency_is_present = false;
      this->last_checked_date = "";
      this->last_checked_date_is_present = false;
      this->geoid_used = "";
      this->geoid_used_is_present = false;
    }
  }

  explicit DataParameters_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : process_method(_alloc),
    process_agency(_alloc),
    last_checked_date(_alloc),
    geoid_used(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->process_method = "";
      this->process_method_is_present = false;
      this->process_agency = "";
      this->process_agency_is_present = false;
      this->last_checked_date = "";
      this->last_checked_date_is_present = false;
      this->geoid_used = "";
      this->geoid_used_is_present = false;
    }
  }

  // field types and members
  using _process_method_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _process_method_type process_method;
  using _process_method_is_present_type =
    bool;
  _process_method_is_present_type process_method_is_present;
  using _process_agency_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _process_agency_type process_agency;
  using _process_agency_is_present_type =
    bool;
  _process_agency_is_present_type process_agency_is_present;
  using _last_checked_date_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _last_checked_date_type last_checked_date;
  using _last_checked_date_is_present_type =
    bool;
  _last_checked_date_is_present_type last_checked_date_is_present;
  using _geoid_used_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _geoid_used_type geoid_used;
  using _geoid_used_is_present_type =
    bool;
  _geoid_used_is_present_type geoid_used_is_present;

  // setters for named parameter idiom
  Type & set__process_method(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->process_method = _arg;
    return *this;
  }
  Type & set__process_method_is_present(
    const bool & _arg)
  {
    this->process_method_is_present = _arg;
    return *this;
  }
  Type & set__process_agency(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->process_agency = _arg;
    return *this;
  }
  Type & set__process_agency_is_present(
    const bool & _arg)
  {
    this->process_agency_is_present = _arg;
    return *this;
  }
  Type & set__last_checked_date(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->last_checked_date = _arg;
    return *this;
  }
  Type & set__last_checked_date_is_present(
    const bool & _arg)
  {
    this->last_checked_date_is_present = _arg;
    return *this;
  }
  Type & set__geoid_used(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->geoid_used = _arg;
    return *this;
  }
  Type & set__geoid_used_is_present(
    const bool & _arg)
  {
    this->geoid_used_is_present = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PROCESS_METHOD_MIN_SIZE =
    1u;
  static constexpr uint8_t PROCESS_METHOD_MAX_SIZE =
    255u;
  static constexpr uint8_t PROCESS_AGENCY_MIN_SIZE =
    1u;
  static constexpr uint8_t PROCESS_AGENCY_MAX_SIZE =
    255u;
  static constexpr uint8_t LAST_CHECKED_DATE_MIN_SIZE =
    1u;
  static constexpr uint8_t LAST_CHECKED_DATE_MAX_SIZE =
    255u;
  static constexpr uint8_t GEOID_USED_MIN_SIZE =
    1u;
  static constexpr uint8_t GEOID_USED_MAX_SIZE =
    255u;

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__DataParameters
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__DataParameters
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DataParameters_ & other) const
  {
    if (this->process_method != other.process_method) {
      return false;
    }
    if (this->process_method_is_present != other.process_method_is_present) {
      return false;
    }
    if (this->process_agency != other.process_agency) {
      return false;
    }
    if (this->process_agency_is_present != other.process_agency_is_present) {
      return false;
    }
    if (this->last_checked_date != other.last_checked_date) {
      return false;
    }
    if (this->last_checked_date_is_present != other.last_checked_date_is_present) {
      return false;
    }
    if (this->geoid_used != other.geoid_used) {
      return false;
    }
    if (this->geoid_used_is_present != other.geoid_used_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const DataParameters_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DataParameters_

// alias to use template instance with default allocator
using DataParameters =
  etsi_its_mapem_ts_msgs::msg::DataParameters_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::PROCESS_METHOD_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::PROCESS_METHOD_MAX_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::PROCESS_AGENCY_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::PROCESS_AGENCY_MAX_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::LAST_CHECKED_DATE_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::LAST_CHECKED_DATE_MAX_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::GEOID_USED_MIN_SIZE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t DataParameters_<ContainerAllocator>::GEOID_USED_MAX_SIZE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__DATA_PARAMETERS__STRUCT_HPP_
