// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mapem_ts_msgs:msg/GenericLane.idl
// generated code does not contain a copyright notice
#include "etsi_its_mapem_ts_msgs/msg/detail/generic_lane__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `lane_id`
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__functions.h"
// Member `name`
#include "etsi_its_mapem_ts_msgs/msg/detail/descriptive_name__functions.h"
// Member `ingress_approach`
// Member `egress_approach`
#include "etsi_its_mapem_ts_msgs/msg/detail/approach_id__functions.h"
// Member `lane_attributes`
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes__functions.h"
// Member `maneuvers`
#include "etsi_its_mapem_ts_msgs/msg/detail/allowed_maneuvers__functions.h"
// Member `node_list`
#include "etsi_its_mapem_ts_msgs/msg/detail/node_list_xy__functions.h"
// Member `connects_to`
#include "etsi_its_mapem_ts_msgs/msg/detail/connects_to_list__functions.h"
// Member `overlays`
#include "etsi_its_mapem_ts_msgs/msg/detail/overlay_lane_list__functions.h"

bool
etsi_its_mapem_ts_msgs__msg__GenericLane__init(etsi_its_mapem_ts_msgs__msg__GenericLane * msg)
{
  if (!msg) {
    return false;
  }
  // lane_id
  if (!etsi_its_mapem_ts_msgs__msg__LaneID__init(&msg->lane_id)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // name
  if (!etsi_its_mapem_ts_msgs__msg__DescriptiveName__init(&msg->name)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // name_is_present
  // ingress_approach
  if (!etsi_its_mapem_ts_msgs__msg__ApproachID__init(&msg->ingress_approach)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // ingress_approach_is_present
  // egress_approach
  if (!etsi_its_mapem_ts_msgs__msg__ApproachID__init(&msg->egress_approach)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // egress_approach_is_present
  // lane_attributes
  if (!etsi_its_mapem_ts_msgs__msg__LaneAttributes__init(&msg->lane_attributes)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // maneuvers
  if (!etsi_its_mapem_ts_msgs__msg__AllowedManeuvers__init(&msg->maneuvers)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // maneuvers_is_present
  // node_list
  if (!etsi_its_mapem_ts_msgs__msg__NodeListXY__init(&msg->node_list)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // connects_to
  if (!etsi_its_mapem_ts_msgs__msg__ConnectsToList__init(&msg->connects_to)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // connects_to_is_present
  // overlays
  if (!etsi_its_mapem_ts_msgs__msg__OverlayLaneList__init(&msg->overlays)) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
    return false;
  }
  // overlays_is_present
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__GenericLane__fini(etsi_its_mapem_ts_msgs__msg__GenericLane * msg)
{
  if (!msg) {
    return;
  }
  // lane_id
  etsi_its_mapem_ts_msgs__msg__LaneID__fini(&msg->lane_id);
  // name
  etsi_its_mapem_ts_msgs__msg__DescriptiveName__fini(&msg->name);
  // name_is_present
  // ingress_approach
  etsi_its_mapem_ts_msgs__msg__ApproachID__fini(&msg->ingress_approach);
  // ingress_approach_is_present
  // egress_approach
  etsi_its_mapem_ts_msgs__msg__ApproachID__fini(&msg->egress_approach);
  // egress_approach_is_present
  // lane_attributes
  etsi_its_mapem_ts_msgs__msg__LaneAttributes__fini(&msg->lane_attributes);
  // maneuvers
  etsi_its_mapem_ts_msgs__msg__AllowedManeuvers__fini(&msg->maneuvers);
  // maneuvers_is_present
  // node_list
  etsi_its_mapem_ts_msgs__msg__NodeListXY__fini(&msg->node_list);
  // connects_to
  etsi_its_mapem_ts_msgs__msg__ConnectsToList__fini(&msg->connects_to);
  // connects_to_is_present
  // overlays
  etsi_its_mapem_ts_msgs__msg__OverlayLaneList__fini(&msg->overlays);
  // overlays_is_present
}

bool
etsi_its_mapem_ts_msgs__msg__GenericLane__are_equal(const etsi_its_mapem_ts_msgs__msg__GenericLane * lhs, const etsi_its_mapem_ts_msgs__msg__GenericLane * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // lane_id
  if (!etsi_its_mapem_ts_msgs__msg__LaneID__are_equal(
      &(lhs->lane_id), &(rhs->lane_id)))
  {
    return false;
  }
  // name
  if (!etsi_its_mapem_ts_msgs__msg__DescriptiveName__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // name_is_present
  if (lhs->name_is_present != rhs->name_is_present) {
    return false;
  }
  // ingress_approach
  if (!etsi_its_mapem_ts_msgs__msg__ApproachID__are_equal(
      &(lhs->ingress_approach), &(rhs->ingress_approach)))
  {
    return false;
  }
  // ingress_approach_is_present
  if (lhs->ingress_approach_is_present != rhs->ingress_approach_is_present) {
    return false;
  }
  // egress_approach
  if (!etsi_its_mapem_ts_msgs__msg__ApproachID__are_equal(
      &(lhs->egress_approach), &(rhs->egress_approach)))
  {
    return false;
  }
  // egress_approach_is_present
  if (lhs->egress_approach_is_present != rhs->egress_approach_is_present) {
    return false;
  }
  // lane_attributes
  if (!etsi_its_mapem_ts_msgs__msg__LaneAttributes__are_equal(
      &(lhs->lane_attributes), &(rhs->lane_attributes)))
  {
    return false;
  }
  // maneuvers
  if (!etsi_its_mapem_ts_msgs__msg__AllowedManeuvers__are_equal(
      &(lhs->maneuvers), &(rhs->maneuvers)))
  {
    return false;
  }
  // maneuvers_is_present
  if (lhs->maneuvers_is_present != rhs->maneuvers_is_present) {
    return false;
  }
  // node_list
  if (!etsi_its_mapem_ts_msgs__msg__NodeListXY__are_equal(
      &(lhs->node_list), &(rhs->node_list)))
  {
    return false;
  }
  // connects_to
  if (!etsi_its_mapem_ts_msgs__msg__ConnectsToList__are_equal(
      &(lhs->connects_to), &(rhs->connects_to)))
  {
    return false;
  }
  // connects_to_is_present
  if (lhs->connects_to_is_present != rhs->connects_to_is_present) {
    return false;
  }
  // overlays
  if (!etsi_its_mapem_ts_msgs__msg__OverlayLaneList__are_equal(
      &(lhs->overlays), &(rhs->overlays)))
  {
    return false;
  }
  // overlays_is_present
  if (lhs->overlays_is_present != rhs->overlays_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__GenericLane__copy(
  const etsi_its_mapem_ts_msgs__msg__GenericLane * input,
  etsi_its_mapem_ts_msgs__msg__GenericLane * output)
{
  if (!input || !output) {
    return false;
  }
  // lane_id
  if (!etsi_its_mapem_ts_msgs__msg__LaneID__copy(
      &(input->lane_id), &(output->lane_id)))
  {
    return false;
  }
  // name
  if (!etsi_its_mapem_ts_msgs__msg__DescriptiveName__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // name_is_present
  output->name_is_present = input->name_is_present;
  // ingress_approach
  if (!etsi_its_mapem_ts_msgs__msg__ApproachID__copy(
      &(input->ingress_approach), &(output->ingress_approach)))
  {
    return false;
  }
  // ingress_approach_is_present
  output->ingress_approach_is_present = input->ingress_approach_is_present;
  // egress_approach
  if (!etsi_its_mapem_ts_msgs__msg__ApproachID__copy(
      &(input->egress_approach), &(output->egress_approach)))
  {
    return false;
  }
  // egress_approach_is_present
  output->egress_approach_is_present = input->egress_approach_is_present;
  // lane_attributes
  if (!etsi_its_mapem_ts_msgs__msg__LaneAttributes__copy(
      &(input->lane_attributes), &(output->lane_attributes)))
  {
    return false;
  }
  // maneuvers
  if (!etsi_its_mapem_ts_msgs__msg__AllowedManeuvers__copy(
      &(input->maneuvers), &(output->maneuvers)))
  {
    return false;
  }
  // maneuvers_is_present
  output->maneuvers_is_present = input->maneuvers_is_present;
  // node_list
  if (!etsi_its_mapem_ts_msgs__msg__NodeListXY__copy(
      &(input->node_list), &(output->node_list)))
  {
    return false;
  }
  // connects_to
  if (!etsi_its_mapem_ts_msgs__msg__ConnectsToList__copy(
      &(input->connects_to), &(output->connects_to)))
  {
    return false;
  }
  // connects_to_is_present
  output->connects_to_is_present = input->connects_to_is_present;
  // overlays
  if (!etsi_its_mapem_ts_msgs__msg__OverlayLaneList__copy(
      &(input->overlays), &(output->overlays)))
  {
    return false;
  }
  // overlays_is_present
  output->overlays_is_present = input->overlays_is_present;
  return true;
}

etsi_its_mapem_ts_msgs__msg__GenericLane *
etsi_its_mapem_ts_msgs__msg__GenericLane__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__GenericLane * msg = (etsi_its_mapem_ts_msgs__msg__GenericLane *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__GenericLane), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mapem_ts_msgs__msg__GenericLane));
  bool success = etsi_its_mapem_ts_msgs__msg__GenericLane__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mapem_ts_msgs__msg__GenericLane__destroy(etsi_its_mapem_ts_msgs__msg__GenericLane * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__init(etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__GenericLane * data = NULL;

  if (size) {
    data = (etsi_its_mapem_ts_msgs__msg__GenericLane *)allocator.zero_allocate(size, sizeof(etsi_its_mapem_ts_msgs__msg__GenericLane), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mapem_ts_msgs__msg__GenericLane__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mapem_ts_msgs__msg__GenericLane__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__fini(etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mapem_ts_msgs__msg__GenericLane__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence *
etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * array = (etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__destroy(etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__are_equal(const etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * lhs, const etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__GenericLane__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence__copy(
  const etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * input,
  etsi_its_mapem_ts_msgs__msg__GenericLane__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mapem_ts_msgs__msg__GenericLane);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mapem_ts_msgs__msg__GenericLane * data =
      (etsi_its_mapem_ts_msgs__msg__GenericLane *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mapem_ts_msgs__msg__GenericLane__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mapem_ts_msgs__msg__GenericLane__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__GenericLane__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
