// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/GenericLane.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/generic_lane.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__GENERIC_LANE__TRAITS_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__GENERIC_LANE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mapem_ts_msgs/msg/detail/generic_lane__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'lane_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_id__traits.hpp"
// Member 'name'
#include "etsi_its_mapem_ts_msgs/msg/detail/descriptive_name__traits.hpp"
// Member 'ingress_approach'
// Member 'egress_approach'
#include "etsi_its_mapem_ts_msgs/msg/detail/approach_id__traits.hpp"
// Member 'lane_attributes'
#include "etsi_its_mapem_ts_msgs/msg/detail/lane_attributes__traits.hpp"
// Member 'maneuvers'
#include "etsi_its_mapem_ts_msgs/msg/detail/allowed_maneuvers__traits.hpp"
// Member 'node_list'
#include "etsi_its_mapem_ts_msgs/msg/detail/node_list_xy__traits.hpp"
// Member 'connects_to'
#include "etsi_its_mapem_ts_msgs/msg/detail/connects_to_list__traits.hpp"
// Member 'overlays'
#include "etsi_its_mapem_ts_msgs/msg/detail/overlay_lane_list__traits.hpp"

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GenericLane & msg,
  std::ostream & out)
{
  out << "{";
  // member: lane_id
  {
    out << "lane_id: ";
    to_flow_style_yaml(msg.lane_id, out);
    out << ", ";
  }

  // member: name
  {
    out << "name: ";
    to_flow_style_yaml(msg.name, out);
    out << ", ";
  }

  // member: name_is_present
  {
    out << "name_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.name_is_present, out);
    out << ", ";
  }

  // member: ingress_approach
  {
    out << "ingress_approach: ";
    to_flow_style_yaml(msg.ingress_approach, out);
    out << ", ";
  }

  // member: ingress_approach_is_present
  {
    out << "ingress_approach_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.ingress_approach_is_present, out);
    out << ", ";
  }

  // member: egress_approach
  {
    out << "egress_approach: ";
    to_flow_style_yaml(msg.egress_approach, out);
    out << ", ";
  }

  // member: egress_approach_is_present
  {
    out << "egress_approach_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.egress_approach_is_present, out);
    out << ", ";
  }

  // member: lane_attributes
  {
    out << "lane_attributes: ";
    to_flow_style_yaml(msg.lane_attributes, out);
    out << ", ";
  }

  // member: maneuvers
  {
    out << "maneuvers: ";
    to_flow_style_yaml(msg.maneuvers, out);
    out << ", ";
  }

  // member: maneuvers_is_present
  {
    out << "maneuvers_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuvers_is_present, out);
    out << ", ";
  }

  // member: node_list
  {
    out << "node_list: ";
    to_flow_style_yaml(msg.node_list, out);
    out << ", ";
  }

  // member: connects_to
  {
    out << "connects_to: ";
    to_flow_style_yaml(msg.connects_to, out);
    out << ", ";
  }

  // member: connects_to_is_present
  {
    out << "connects_to_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connects_to_is_present, out);
    out << ", ";
  }

  // member: overlays
  {
    out << "overlays: ";
    to_flow_style_yaml(msg.overlays, out);
    out << ", ";
  }

  // member: overlays_is_present
  {
    out << "overlays_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.overlays_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GenericLane & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lane_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_id:\n";
    to_block_style_yaml(msg.lane_id, out, indentation + 2);
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name:\n";
    to_block_style_yaml(msg.name, out, indentation + 2);
  }

  // member: name_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.name_is_present, out);
    out << "\n";
  }

  // member: ingress_approach
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ingress_approach:\n";
    to_block_style_yaml(msg.ingress_approach, out, indentation + 2);
  }

  // member: ingress_approach_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ingress_approach_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.ingress_approach_is_present, out);
    out << "\n";
  }

  // member: egress_approach
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "egress_approach:\n";
    to_block_style_yaml(msg.egress_approach, out, indentation + 2);
  }

  // member: egress_approach_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "egress_approach_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.egress_approach_is_present, out);
    out << "\n";
  }

  // member: lane_attributes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_attributes:\n";
    to_block_style_yaml(msg.lane_attributes, out, indentation + 2);
  }

  // member: maneuvers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuvers:\n";
    to_block_style_yaml(msg.maneuvers, out, indentation + 2);
  }

  // member: maneuvers_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuvers_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuvers_is_present, out);
    out << "\n";
  }

  // member: node_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "node_list:\n";
    to_block_style_yaml(msg.node_list, out, indentation + 2);
  }

  // member: connects_to
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connects_to:\n";
    to_block_style_yaml(msg.connects_to, out, indentation + 2);
  }

  // member: connects_to_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connects_to_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connects_to_is_present, out);
    out << "\n";
  }

  // member: overlays
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "overlays:\n";
    to_block_style_yaml(msg.overlays, out, indentation + 2);
  }

  // member: overlays_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "overlays_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.overlays_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GenericLane & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mapem_ts_msgs::msg::GenericLane & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mapem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mapem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mapem_ts_msgs::msg::GenericLane & msg)
{
  return etsi_its_mapem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mapem_ts_msgs::msg::GenericLane>()
{
  return "etsi_its_mapem_ts_msgs::msg::GenericLane";
}

template<>
inline const char * name<etsi_its_mapem_ts_msgs::msg::GenericLane>()
{
  return "etsi_its_mapem_ts_msgs/msg/GenericLane";
}

template<>
struct has_fixed_size<etsi_its_mapem_ts_msgs::msg::GenericLane>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::ApproachID>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::ConnectsToList>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::DescriptiveName>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::LaneAttributes>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::LaneID>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::NodeListXY>::value && has_fixed_size<etsi_its_mapem_ts_msgs::msg::OverlayLaneList>::value> {};

template<>
struct has_bounded_size<etsi_its_mapem_ts_msgs::msg::GenericLane>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mapem_ts_msgs::msg::AllowedManeuvers>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::ApproachID>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::ConnectsToList>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::DescriptiveName>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::LaneAttributes>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::LaneID>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::NodeListXY>::value && has_bounded_size<etsi_its_mapem_ts_msgs::msg::OverlayLaneList>::value> {};

template<>
struct is_message<etsi_its_mapem_ts_msgs::msg::GenericLane>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__GENERIC_LANE__TRAITS_HPP_
