// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/MapData.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/map_data.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__MAP_DATA__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__MAP_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'time_stamp'
#include "etsi_its_mapem_ts_msgs/msg/detail/minute_of_the_year__struct.hpp"
// Member 'msg_issue_revision'
#include "etsi_its_mapem_ts_msgs/msg/detail/msg_count__struct.hpp"
// Member 'layer_type'
#include "etsi_its_mapem_ts_msgs/msg/detail/layer_type__struct.hpp"
// Member 'layer_id'
#include "etsi_its_mapem_ts_msgs/msg/detail/layer_id__struct.hpp"
// Member 'intersections'
#include "etsi_its_mapem_ts_msgs/msg/detail/intersection_geometry_list__struct.hpp"
// Member 'road_segments'
#include "etsi_its_mapem_ts_msgs/msg/detail/road_segment_list__struct.hpp"
// Member 'data_parameters'
#include "etsi_its_mapem_ts_msgs/msg/detail/data_parameters__struct.hpp"
// Member 'restriction_list'
#include "etsi_its_mapem_ts_msgs/msg/detail/restriction_class_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__MapData __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__MapData __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MapData_
{
  using Type = MapData_<ContainerAllocator>;

  explicit MapData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : time_stamp(_init),
    msg_issue_revision(_init),
    layer_type(_init),
    layer_id(_init),
    intersections(_init),
    road_segments(_init),
    data_parameters(_init),
    restriction_list(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_stamp_is_present = false;
      this->layer_type_is_present = false;
      this->layer_id_is_present = false;
      this->intersections_is_present = false;
      this->road_segments_is_present = false;
      this->data_parameters_is_present = false;
      this->restriction_list_is_present = false;
    }
  }

  explicit MapData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : time_stamp(_alloc, _init),
    msg_issue_revision(_alloc, _init),
    layer_type(_alloc, _init),
    layer_id(_alloc, _init),
    intersections(_alloc, _init),
    road_segments(_alloc, _init),
    data_parameters(_alloc, _init),
    restriction_list(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_stamp_is_present = false;
      this->layer_type_is_present = false;
      this->layer_id_is_present = false;
      this->intersections_is_present = false;
      this->road_segments_is_present = false;
      this->data_parameters_is_present = false;
      this->restriction_list_is_present = false;
    }
  }

  // field types and members
  using _time_stamp_type =
    etsi_its_mapem_ts_msgs::msg::MinuteOfTheYear_<ContainerAllocator>;
  _time_stamp_type time_stamp;
  using _time_stamp_is_present_type =
    bool;
  _time_stamp_is_present_type time_stamp_is_present;
  using _msg_issue_revision_type =
    etsi_its_mapem_ts_msgs::msg::MsgCount_<ContainerAllocator>;
  _msg_issue_revision_type msg_issue_revision;
  using _layer_type_type =
    etsi_its_mapem_ts_msgs::msg::LayerType_<ContainerAllocator>;
  _layer_type_type layer_type;
  using _layer_type_is_present_type =
    bool;
  _layer_type_is_present_type layer_type_is_present;
  using _layer_id_type =
    etsi_its_mapem_ts_msgs::msg::LayerID_<ContainerAllocator>;
  _layer_id_type layer_id;
  using _layer_id_is_present_type =
    bool;
  _layer_id_is_present_type layer_id_is_present;
  using _intersections_type =
    etsi_its_mapem_ts_msgs::msg::IntersectionGeometryList_<ContainerAllocator>;
  _intersections_type intersections;
  using _intersections_is_present_type =
    bool;
  _intersections_is_present_type intersections_is_present;
  using _road_segments_type =
    etsi_its_mapem_ts_msgs::msg::RoadSegmentList_<ContainerAllocator>;
  _road_segments_type road_segments;
  using _road_segments_is_present_type =
    bool;
  _road_segments_is_present_type road_segments_is_present;
  using _data_parameters_type =
    etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator>;
  _data_parameters_type data_parameters;
  using _data_parameters_is_present_type =
    bool;
  _data_parameters_is_present_type data_parameters_is_present;
  using _restriction_list_type =
    etsi_its_mapem_ts_msgs::msg::RestrictionClassList_<ContainerAllocator>;
  _restriction_list_type restriction_list;
  using _restriction_list_is_present_type =
    bool;
  _restriction_list_is_present_type restriction_list_is_present;

  // setters for named parameter idiom
  Type & set__time_stamp(
    const etsi_its_mapem_ts_msgs::msg::MinuteOfTheYear_<ContainerAllocator> & _arg)
  {
    this->time_stamp = _arg;
    return *this;
  }
  Type & set__time_stamp_is_present(
    const bool & _arg)
  {
    this->time_stamp_is_present = _arg;
    return *this;
  }
  Type & set__msg_issue_revision(
    const etsi_its_mapem_ts_msgs::msg::MsgCount_<ContainerAllocator> & _arg)
  {
    this->msg_issue_revision = _arg;
    return *this;
  }
  Type & set__layer_type(
    const etsi_its_mapem_ts_msgs::msg::LayerType_<ContainerAllocator> & _arg)
  {
    this->layer_type = _arg;
    return *this;
  }
  Type & set__layer_type_is_present(
    const bool & _arg)
  {
    this->layer_type_is_present = _arg;
    return *this;
  }
  Type & set__layer_id(
    const etsi_its_mapem_ts_msgs::msg::LayerID_<ContainerAllocator> & _arg)
  {
    this->layer_id = _arg;
    return *this;
  }
  Type & set__layer_id_is_present(
    const bool & _arg)
  {
    this->layer_id_is_present = _arg;
    return *this;
  }
  Type & set__intersections(
    const etsi_its_mapem_ts_msgs::msg::IntersectionGeometryList_<ContainerAllocator> & _arg)
  {
    this->intersections = _arg;
    return *this;
  }
  Type & set__intersections_is_present(
    const bool & _arg)
  {
    this->intersections_is_present = _arg;
    return *this;
  }
  Type & set__road_segments(
    const etsi_its_mapem_ts_msgs::msg::RoadSegmentList_<ContainerAllocator> & _arg)
  {
    this->road_segments = _arg;
    return *this;
  }
  Type & set__road_segments_is_present(
    const bool & _arg)
  {
    this->road_segments_is_present = _arg;
    return *this;
  }
  Type & set__data_parameters(
    const etsi_its_mapem_ts_msgs::msg::DataParameters_<ContainerAllocator> & _arg)
  {
    this->data_parameters = _arg;
    return *this;
  }
  Type & set__data_parameters_is_present(
    const bool & _arg)
  {
    this->data_parameters_is_present = _arg;
    return *this;
  }
  Type & set__restriction_list(
    const etsi_its_mapem_ts_msgs::msg::RestrictionClassList_<ContainerAllocator> & _arg)
  {
    this->restriction_list = _arg;
    return *this;
  }
  Type & set__restriction_list_is_present(
    const bool & _arg)
  {
    this->restriction_list_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__MapData
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__MapData
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::MapData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MapData_ & other) const
  {
    if (this->time_stamp != other.time_stamp) {
      return false;
    }
    if (this->time_stamp_is_present != other.time_stamp_is_present) {
      return false;
    }
    if (this->msg_issue_revision != other.msg_issue_revision) {
      return false;
    }
    if (this->layer_type != other.layer_type) {
      return false;
    }
    if (this->layer_type_is_present != other.layer_type_is_present) {
      return false;
    }
    if (this->layer_id != other.layer_id) {
      return false;
    }
    if (this->layer_id_is_present != other.layer_id_is_present) {
      return false;
    }
    if (this->intersections != other.intersections) {
      return false;
    }
    if (this->intersections_is_present != other.intersections_is_present) {
      return false;
    }
    if (this->road_segments != other.road_segments) {
      return false;
    }
    if (this->road_segments_is_present != other.road_segments_is_present) {
      return false;
    }
    if (this->data_parameters != other.data_parameters) {
      return false;
    }
    if (this->data_parameters_is_present != other.data_parameters_is_present) {
      return false;
    }
    if (this->restriction_list != other.restriction_list) {
      return false;
    }
    if (this->restriction_list_is_present != other.restriction_list_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const MapData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MapData_

// alias to use template instance with default allocator
using MapData =
  etsi_its_mapem_ts_msgs::msg::MapData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__MAP_DATA__STRUCT_HPP_
