// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mapem_ts_msgs:msg/RegulatorySpeedLimit.idl
// generated code does not contain a copyright notice
#include "etsi_its_mapem_ts_msgs/msg/detail/regulatory_speed_limit__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `type`
#include "etsi_its_mapem_ts_msgs/msg/detail/speed_limit_type__functions.h"
// Member `speed`
#include "etsi_its_mapem_ts_msgs/msg/detail/velocity__functions.h"

bool
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__init(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * msg)
{
  if (!msg) {
    return false;
  }
  // type
  if (!etsi_its_mapem_ts_msgs__msg__SpeedLimitType__init(&msg->type)) {
    etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__fini(msg);
    return false;
  }
  // speed
  if (!etsi_its_mapem_ts_msgs__msg__Velocity__init(&msg->speed)) {
    etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__fini(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * msg)
{
  if (!msg) {
    return;
  }
  // type
  etsi_its_mapem_ts_msgs__msg__SpeedLimitType__fini(&msg->type);
  // speed
  etsi_its_mapem_ts_msgs__msg__Velocity__fini(&msg->speed);
}

bool
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__are_equal(const etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * lhs, const etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // type
  if (!etsi_its_mapem_ts_msgs__msg__SpeedLimitType__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // speed
  if (!etsi_its_mapem_ts_msgs__msg__Velocity__are_equal(
      &(lhs->speed), &(rhs->speed)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__copy(
  const etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * input,
  etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * output)
{
  if (!input || !output) {
    return false;
  }
  // type
  if (!etsi_its_mapem_ts_msgs__msg__SpeedLimitType__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // speed
  if (!etsi_its_mapem_ts_msgs__msg__Velocity__copy(
      &(input->speed), &(output->speed)))
  {
    return false;
  }
  return true;
}

etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit *
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * msg = (etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit));
  bool success = etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__destroy(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__init(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * data = NULL;

  if (size) {
    data = (etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit *)allocator.zero_allocate(size, sizeof(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__fini(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence *
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * array = (etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence *)allocator.allocate(sizeof(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__destroy(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__are_equal(const etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * lhs, const etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence__copy(
  const etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * input,
  etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit * data =
      (etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mapem_ts_msgs__msg__RegulatorySpeedLimit__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
