// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mapem_ts_msgs:msg/RestrictionAppliesTo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_mapem_ts_msgs/msg/restriction_applies_to.hpp"


#ifndef ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__RESTRICTION_APPLIES_TO__STRUCT_HPP_
#define ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__RESTRICTION_APPLIES_TO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo __declspec(deprecated)
#endif

namespace etsi_its_mapem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RestrictionAppliesTo_
{
  using Type = RestrictionAppliesTo_<ContainerAllocator>;

  explicit RestrictionAppliesTo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit RestrictionAppliesTo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NONE =
    0u;
  static constexpr uint8_t EQUIPPED_TRANSIT =
    1u;
  static constexpr uint8_t EQUIPPED_TAXIS =
    2u;
  static constexpr uint8_t EQUIPPED_OTHER =
    3u;
  static constexpr uint8_t EMISSION_COMPLIANT =
    4u;
  static constexpr uint8_t EQUIPPED_BICYCLE =
    5u;
  static constexpr uint8_t WEIGHT_COMPLIANT =
    6u;
  static constexpr uint8_t HEIGHT_COMPLIANT =
    7u;
  static constexpr uint8_t PEDESTRIANS =
    8u;
  static constexpr uint8_t SLOW_MOVING_PERSONS =
    9u;
  static constexpr uint8_t WHEELCHAIR_USERS =
    10u;
  static constexpr uint8_t VISUAL_DISABILITIES =
    11u;
  static constexpr uint8_t AUDIO_DISABILITIES =
    12u;
  static constexpr uint8_t OTHER_UNKNOWN_DISABILITIES =
    13u;

  // pointer types
  using RawPtr =
    etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mapem_ts_msgs__msg__RestrictionAppliesTo
    std::shared_ptr<etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RestrictionAppliesTo_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const RestrictionAppliesTo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RestrictionAppliesTo_

// alias to use template instance with default allocator
using RestrictionAppliesTo =
  etsi_its_mapem_ts_msgs::msg::RestrictionAppliesTo_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::EQUIPPED_TRANSIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::EQUIPPED_TAXIS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::EQUIPPED_OTHER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::EMISSION_COMPLIANT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::EQUIPPED_BICYCLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::WEIGHT_COMPLIANT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::HEIGHT_COMPLIANT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::PEDESTRIANS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::SLOW_MOVING_PERSONS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::WHEELCHAIR_USERS;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::VISUAL_DISABILITIES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::AUDIO_DISABILITIES;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t RestrictionAppliesTo_<ContainerAllocator>::OTHER_UNKNOWN_DISABILITIES;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_mapem_ts_msgs

#endif  // ETSI_ITS_MAPEM_TS_MSGS__MSG__DETAIL__RESTRICTION_APPLIES_TO__STRUCT_HPP_
